searchNodes=[{"doc":"Element responsible for parsing WAV files. It requires WAV file in uncompressed, PCM format on the input (otherwise error is raised) and provides raw audio on the output. WAV header is parsed to extract metadata for creating caps. Then it is dropped and only samples are sent to the next element. The element has one option - frames_per_buffer . User can specify number of frames sent in one buffer when demand unit on the output is :buffers . One frame contains bits per sample x number of channels bits. WAV Header 0 4 8 12 16 _________________________________________________________________________________ 0 | | | | | | &quot;RIFF&quot; | file length | &quot;WAVE&quot; | &quot;fmt &quot; | | | | | | | ___________________ | ___________________ | ___________________ | ___________________ | 16 | | | | | | | format chunk | format | number of | sample | data transmission | | length | ( 1 - PCM ) | channels | rate | rate | | ___________________ | _________ | _________ | ___________________ | ___________________ | 32 | block | bits | | | | | align | per | &quot;fact&quot; | fact chunk | samples per | | unit | sample | | length | channel | | _________ | _________ | ___________________ | ___________________ | ___________________ | 48 | | | | | &quot;data&quot; | data length | DATA | | | in bytes | | | ___________________ | ___________________ | _______________________________________ | Header may contain additional bytes between bits per sample and &quot;fact&quot; in case of format different from 1 (1 represents PCM / uncompressed format). Length of block from format until &quot;fact&quot; is present in format chunk length (it is 16 for PCM). Blocks from byte 36 to 48 are optional. There can be additional bytes after samples per channel if fact chunk length contains number bigger than 4. Parsing Stages of parsing: :init - Parser waits for the first 22 bytes. After getting them, it parses these bytes to ensure that it is a WAV file. Parser knows format chunk length and format , so it is able to raise an error in case of different format than 1 (PCM) or different length than 16 (for PCM). After parsing, the stage is set to :format . :format - Parser waits for the next 22 bytes - fmt chunk (bytes 20 - 35) without format and either &quot;fact&quot; and fact chunk length or &quot;data&quot; and data length in bytes . Then it parses it and create Membrane.Caps.Audio.Raw struct with audio format to send it as caps to the next element. Stage is set to :fact or :data depending on last 8 bytes. :fact - Parser waits for 8 + fact chunk length bytes. It parses them only to check if the header is correct, but does not use that data in any way. After parsing, the stage is set to :data . :data - header is already fully parsed. All new data from the input is sent to the output. Element options Passed via struct Membrane.WAV.Parser.t/0 frames_per_buffer pos_integer ( ) Default value: 2048 Assumed number of raw audio frames in each buffer. Used when converting demand from buffers into bytes. Pads :input Availability :always Caps :any Demand unit :bytes Direction :input Mode :pull Name :input :output Availability :always Caps Membrane.Caps.Audio.Raw Direction :output Mode :pull Name :output","ref":"Membrane.WAV.Parser.html","title":"Membrane.WAV.Parser","type":"module"},{"doc":"Returns pads descriptions for Membrane.WAV.Parser","ref":"Membrane.WAV.Parser.html#membrane_pads/0","title":"Membrane.WAV.Parser.membrane_pads/0","type":"function"},{"doc":"Returns description of options available for this module","ref":"Membrane.WAV.Parser.html#options/0","title":"Membrane.WAV.Parser.options/0","type":"function"},{"doc":"Struct containing options for Membrane.WAV.Parser","ref":"Membrane.WAV.Parser.html#t:t/0","title":"Membrane.WAV.Parser.t/0","type":"type"},{"doc":"Module responsible for post-processing serialized WAV files. Due to the fact that Membrane.WAV.Serializer creates WAV file with incorrect file length and data length blocks in the header, post-processing is needed. fix_wav_header/1 fixes that problem. Header description can be found in Membrane.WAV.Parser .","ref":"Membrane.WAV.Postprocessing.html","title":"Membrane.WAV.Postprocessing","type":"module"},{"doc":"Fixes header of the WAV file located in path .","ref":"Membrane.WAV.Postprocessing.html#fix_wav_header/1","title":"Membrane.WAV.Postprocessing.fix_wav_header/1","type":"function"},{"doc":"","ref":"Membrane.WAV.Postprocessing.html#t:fix_error/0","title":"Membrane.WAV.Postprocessing.fix_error/0","type":"type"},{"doc":"Element responsible for raw audio serialization to WAV format. Creates WAV header (its description can be found with Membrane.WAV.Parser ) from received caps and puts it before audio samples. The element assumes that audio is in PCM format. File length and data length can be calculated only after processing all samples, so these values are invalid (always set to 0). Use Membrane.WAV.Postprocessing.fix_wav_header/1 module to fix them. The element has one option - frames_per_buffer . User can specify number of frames sent in one buffer when demand unit on the output is :buffers . One frame contains bits per sample x number of channels bits. Element options Passed via struct Membrane.WAV.Serializer.t/0 frames_per_buffer pos_integer ( ) Default value: 2048 Assumed number of raw audio frames in each buffer. Used when converting demand from buffers into bytes. Pads :input Availability :always Caps Membrane.Caps.Audio.Raw Demand unit :bytes Direction :input Mode :pull Name :input :output Availability :always Caps :any Direction :output Mode :pull Name :output","ref":"Membrane.WAV.Serializer.html","title":"Membrane.WAV.Serializer","type":"module"},{"doc":"Returns pads descriptions for Membrane.WAV.Serializer","ref":"Membrane.WAV.Serializer.html#membrane_pads/0","title":"Membrane.WAV.Serializer.membrane_pads/0","type":"function"},{"doc":"Returns description of options available for this module","ref":"Membrane.WAV.Serializer.html#options/0","title":"Membrane.WAV.Serializer.options/0","type":"function"},{"doc":"Struct containing options for Membrane.WAV.Serializer","ref":"Membrane.WAV.Serializer.html#t:t/0","title":"Membrane.WAV.Serializer.t/0","type":"type"},{"doc":"Membrane WAV Plugin Plugin providing elements handling audio in WAV file format. It is part of Membrane Multimedia Framework .","ref":"readme.html","title":"Membrane WAV Plugin","type":"extras"},{"doc":"The package can be installed by adding membrane_wav_plugin to your list of dependencies in mix.exs : def deps do [ { :membrane_wav_plugin , &quot;~&gt; 0.2.0-alpha&quot; } ] end","ref":"readme.html#installation","title":"Membrane WAV Plugin - Installation","type":"extras"},{"doc":"The Parser requires a WAV file on the input and provides a raw audio in uncompressed, PCM format on the output. Parsing steps: Reading WAV header Extracting audio metadata and sending it through caps to the next element Sending only audio samples to the next elements It can parse only uncompressed audio.","ref":"readme.html#parser","title":"Membrane WAV Plugin - Parser","type":"extras"},{"doc":"The Serializer adds WAV header to the raw audio in uncompressed, PCM format. Warning The Serializer creates header with invalid blocks which depend on the file size. To fix that, using Membrane.WAV.Postprocessing is recommended.","ref":"readme.html#serializer","title":"Membrane WAV Plugin - Serializer","type":"extras"},{"doc":"defmodule Mixing.Pipeline do use Membrane.Pipeline @impl true def handle_init ( _ ) do children = [ file_src : % Membrane.File.Source { location : &quot;/tmp/input.wav&quot; } , parser : Membrane.WAV.Parser , converter : % Membrane.FFmpeg.SWResample.Converter { input_caps : % Membrane.Caps.Audio.Raw { channels : 1 , sample_rate : 16_000 , format : :s16le } , output_caps : % Membrane.Caps.Audio.Raw { channels : 2 , sample_rate : 48_000 , format : :s16le } } , serializer : Membrane.WAV.Serializer , file_sink : % Membrane.File.Sink { location : &quot;/tmp/output.wav&quot; } , ] links = [ link ( :file_src ) |&gt; to ( :parser ) |&gt; to ( :converter ) |&gt; to ( :serializer ) |&gt; to ( :file_sink ) ] { { :ok , spec : % ParentSpec { children : children , links : links } } , %{ } } end end","ref":"readme.html#sample-usage","title":"Membrane WAV Plugin - Sample usage","type":"extras"},{"doc":"Copyright 2021, Software Mansion Licensed under the Apache License, Version 2.0","ref":"readme.html#copyright-and-license","title":"Membrane WAV Plugin - Copyright and License","type":"extras"},{"doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS APPENDIX: How to apply the Apache License to your work. To apply the Apache License to your work, attach the following boilerplate notice, with the fields enclosed by brackets &quot;[]&quot; replaced with your own identifying information. (Don't include the brackets!) The text should be enclosed in the appropriate comment syntax for the file format. We also recommend that a file or class name and description of purpose be included on the same &quot;printed page&quot; as the copyright notice for easier identification within third-party archives. Copyright 2020 Software Mansion Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html","title":"LICENSE","type":"extras"}]